<?php
/*
	Copyright(c) 2011 Shift Tech Inc. All Rights Reserved.
 	http://www.shift-tech.jp/
*/

require_once (dirname(__FILE__).'/../../../lib/common/unitCommon.php');

class extImageBtn extends unitCommon
{
	//------ ユニット毎に必ず設定しなくてはならない変数 -------//
	var $_table = "unit_multiple_data"; 		//公開用テーブル名
	var $_tmptable = "unit_multiple_data_tmp";	//下書き用テーブル名
	var $_unit_dir = "extImageBtn";
	var $columns = array(
    array("column"=>"pageu_code","conv"=>"n","tags"=>false),	//ユニット個別ID
    array("column"=>"pageu_unit_code","conv"=>"n","tags"=>false),	//ユニット個別ID
    array("column"=>"pageu_unit_name","conv"=>"Kva","tags"=>false),	//ユニット個別ID
    array("column"=>"mlt_data1","conv"=>"Kva","tags"=>false),	//データ1
    array("column"=>"mlt_data2","conv"=>"Kva","tags"=>true),	//データ2
    array("column"=>"mlt_data3","conv"=>"Kva","tags"=>false),	//データ3
    array("column"=>"mlt_data4","conv"=>"Kva","tags"=>false),	//データ4
    array("column"=>"mlt_data5","conv"=>"Kva","tags"=>false),	//データ5
    array("column"=>"mlt_data6","conv"=>"Kva","tags"=>false),	//データ6
    array("column"=>"mlt_data7","conv"=>"Kva","tags"=>false),	//データ7
    array("column"=>"mlt_data8","conv"=>"Kva","tags"=>false),	//データ8
    array("column"=>"mlt_data9","conv"=>"Kva","tags"=>false),	//データ9
    array("column"=>"mlt_data10","conv"=>"Kva","tags"=>false),	//データ10
    array("column"=>"mlt_data11","conv"=>"Kva","tags"=>false),	//データ11
    array("column"=>"mlt_data12","conv"=>"Kva","tags"=>false),	//データ12
    array("column"=>"mlt_data13","conv"=>"Kva","tags"=>false),	//データ13
    array("column"=>"mlt_data14","conv"=>"Kva","tags"=>false),	//データ14
    array("column"=>"mlt_data15","conv"=>"Kva","tags"=>false),	//データ15
    array("column"=>"mlt_data16","conv"=>"Kva","tags"=>false),	//データ16
    array("column"=>"mlt_data17","conv"=>"Kva","tags"=>false),	//データ17
    array("column"=>"mlt_data18","conv"=>"Kva","tags"=>false),	//データ18
    array("column"=>"mlt_data19","conv"=>"Kva","tags"=>false),	//データ19
    array("column"=>"mlt_data20","conv"=>"Kva","tags"=>false),	//データ20
    array("column"=>"mlt_data21","conv"=>"Kva","tags"=>false),	//データ21
    array("column"=>"mlt_data22","conv"=>"Kva","tags"=>false),	//データ22
    array("column"=>"mlt_data23","conv"=>"Kva","tags"=>false),	//データ23
    array("column"=>"mlt_data24","conv"=>"Kva","tags"=>false),	//データ24
    array("column"=>"mlt_data25","conv"=>"Kva","tags"=>false),	//データ25
    array("column"=>"mlt_data26","conv"=>"Kva","tags"=>false),	//データ26
    array("column"=>"mlt_data27","conv"=>"Kva","tags"=>false),	//データ27
    array("column"=>"mlt_data28","conv"=>"Kva","tags"=>false),	//データ28
    array("column"=>"mlt_data29","conv"=>"Kva","tags"=>false),	//データ29
    array("column"=>"mlt_data30","conv"=>"Kva","tags"=>false),	//データ30 
    array("column"=>"mlt_data31","conv"=>"Kva","tags"=>false),	//データ31
    array("column"=>"mlt_data32","conv"=>"Kva","tags"=>false),	//データ32
    array("column"=>"mlt_data33","conv"=>"Kva","tags"=>false),	//データ33
    array("column"=>"mlt_data34","conv"=>"Kva","tags"=>false),	//データ34
    array("column"=>"mlt_data35","conv"=>"Kva","tags"=>false),	//データ35
    array("column"=>"mlt_data36","conv"=>"Kva","tags"=>false),	//データ36
    array("column"=>"mlt_data37","conv"=>"Kva","tags"=>false),	//データ37
    array("column"=>"mlt_data38","conv"=>"Kva","tags"=>false),	//データ38
    array("column"=>"mlt_data39","conv"=>"Kva","tags"=>false),	//データ39
    array("column"=>"mlt_data40","conv"=>"Kva","tags"=>false),	//データ40
    array("column"=>"trsf_opacity","conv"=>"Kva","tags"=>false),	//
    array("column"=>"trsf_translate_x","conv"=>"Kva","tags"=>false),	//
    array("column"=>"trsf_translate_y","conv"=>"Kva","tags"=>false),	//
    array("column"=>"trsf_translate_z","conv"=>"Kva","tags"=>false),	//
    array("column"=>"trsf_scale_x","conv"=>"Kva","tags"=>false),	//
    array("column"=>"trsf_scale_y","conv"=>"Kva","tags"=>false),	//
    array("column"=>"trsf_scale_z","conv"=>"Kva","tags"=>false),	//
    array("column"=>"trsf_rotate_x","conv"=>"Kva","tags"=>false),	//
    array("column"=>"trsf_rotate_y","conv"=>"Kva","tags"=>false),	//
    array("column"=>"trsf_rotate_z","conv"=>"Kva","tags"=>false),	//
    array("column"=>"trsf_skew_x","conv"=>"Kva","tags"=>false),	//
    array("column"=>"trsf_skew_y","conv"=>"Kva","tags"=>false),	//
    array("column"=>"trsf_opacity_to","conv"=>"Kva","tags"=>false),	//
    array("column"=>"trsf_translate_x_to","conv"=>"Kva","tags"=>false),	//
    array("column"=>"trsf_translate_y_to","conv"=>"Kva","tags"=>false),	//
    array("column"=>"trsf_translate_z_to","conv"=>"Kva","tags"=>false),	//
    array("column"=>"trsf_scale_x_to","conv"=>"Kva","tags"=>false),	//
    array("column"=>"trsf_scale_y_to","conv"=>"Kva","tags"=>false),	//
    array("column"=>"trsf_scale_z_to","conv"=>"Kva","tags"=>false),	//
    array("column"=>"trsf_rotate_x_to","conv"=>"Kva","tags"=>false),	//
    array("column"=>"trsf_rotate_y_to","conv"=>"Kva","tags"=>false),	//
    array("column"=>"trsf_rotate_z_to","conv"=>"Kva","tags"=>false),	//
    array("column"=>"trsf_skew_x_to","conv"=>"Kva","tags"=>false),	//
    array("column"=>"trsf_skew_y_to","conv"=>"Kva","tags"=>false),	//
    array("column"=>"trsf_perspective","conv"=>"n","tags"=>false),	//
    array("column"=>"trsf_duration","conv"=>"n","tags"=>false),	//
    array("column"=>"trsf_delay","conv"=>"n","tags"=>false),	//
    array("column"=>"trsf_easing","conv"=>"Kva","tags"=>false),	//
    array("column"=>"trsf_sensitivity","conv"=>"n","tags"=>false),	//
    array("column"=>"trsf_reverse","conv"=>"n","tags"=>false),	//
    array("column"=>"trsf_background_color","conv"=>"n","tags"=>false),	//
    array("column"=>"trsf_border_color","conv"=>"n","tags"=>false),	//
    array("column"=>"trsf_trigger","conv"=>"n","tags"=>false),	//
    array("column"=>"trsf_pos_type","conv"=>"n","tags"=>false),	//
    array("column"=>"bg_color","conv"=>"n","tags"=>false),		//背景色
    array("column"=>"bdr_type","conv"=>"n","tags"=>false),		//枠線
    array("column"=>"btm_padding","conv"=>"n","tags"=>false),	//下方スペース
    array("column"=>"bg_color_sp","conv"=>"n","tags"=>false),		//背景色
    array("column"=>"bdr_type_sp","conv"=>"n","tags"=>false),		//枠線
    array("column"=>"btm_padding_sp","conv"=>"n","tags"=>false),	//下方スペース
    array("column"=>"use_pc_flg","conv"=>"n","tags"=>false),	//PCフラグ
    array("column"=>"use_sp_flg","conv"=>"n","tags"=>false)	//スマホフラグ
  );
  
  var $column_link=array(
    1=>"mt"
    ,2=>"mr"
    ,3=>"mb"
    ,4=>"ml"
    ,5=>"pt"
    ,6=>"pr"
    ,7=>"pb"
    ,8=>"pl"
    ,9=>"mtsp"
    ,10=>"mrsp"
    ,11=>"mbsp"
    ,12=>"mlsp"
    ,13=>"ptsp"
    ,14=>"prsp"
    ,15=>"pbsp"
    ,16=>"plsp"
    ,17=>"border_radius"
    ,18=>"border_width"
    ,19=>"border_color"
    ,20=>"border_style"
    ,21=>"border_radius_anim"
    ,22=>"border_width_anim"
    ,23=>"border_color_anim"
    ,24=>"border_style_anim"
    ,25=>"image_code"
    ,26=>"image_path"
    ,27=>"image_w"
    ,28=>"image_h"
    ,29=>"image_hv_code"
    ,30=>"image_hv_path"
    ,31=>"image_hv_w"
    ,32=>"image_hv_h"
    ,33=>"link_target"
    ,34=>"link_href"
    ,35=>"fx_type"
    ,36=>"fx_duration"
    ,37=>"fx_option"
    ,38=>"align"
    ,39=>"size"
    ,40=>"alt_text"
  );

	//▼変数宣言///////////////////
  var $_align = array('left'=>'left', 'center'=>'center','right'=>'right');
	var $_data;
	var $_separator = "@@@";
  var $_size = array(1=>'横幅に合わせる', 2=>'オリジナルサイズ');
  var $_link_target = array(
    '_self'=>'_self'
    ,'_blank'=>'_blank'
    ,'_parent'=>'_parent'
    ,'_top'=>'_top'
  );
  var $_fx_type=array(
    null=>'----'
    ,'fadeIn'=>'fadeIn'
    ,'fadeOut'=>'fadeOut'
    ,'zoomIn'=>'zoomIn'
    ,'zoomOut'=>'zoomOut'
    ,'scaleUp'=>'scaleUp'
    ,'scaleDown'=>'scaleDown'
    ,'slide'=>'slide'
    ,'slideDown'=>'slideDown'
  );
  var $ease = array(
    "swing"=>"swing"
    ,"easeInQuad"=>"easeInQuad"
    ,"easeOutQuad"=>"easeOutQuad"
    ,"easeInOutQuad"=>"easeInOutQuad"
    ,"easeInCubic"=>"easeInCubic"
    ,"easeOutCubic"=>"easeOutCubic"
    ,"easeInOutCubic"=>"easeInOutCubic"
    ,"easeInQuart"=>"easeInQuart"
    ,"easeOutQuart"=>"easeOutQuart"
    ,"easeInOutQuart"=>"easeInOutQuart"
    ,"easeOutQuint"=>"easeOutQuint"
    ,"easeInOutQuint"=>"easeInOutQuint"
    ,"easeInSine"=>"easeInSine"
    ,"easeOutSine"=>"easeOutSine"
    ,"easeInOutSine"=>"easeInOutSine"
    ,"easeInExpo"=>"easeInExpo"
    ,"easeOutExpo"=>"easeOutExpo"
    ,"easeInOutExpo"=>"easeInOutExpo"
    ,"easeInCirc"=>"easeInCirc"
    ,"easeOutCirc"=>"easeOutCirc"
    ,"easeInOutCirc"=>"easeInOutCirc"
    ,"easeInElastic"=>"easeInElastic"
    ,"easeOutElastic"=>"easeOutElastic"
    ,"easeInOutElastic"=>"easeInOutElastic"
    ,"easeInBack"=>"easeInBack"
    ,"easeOutBack"=>"easeOutBack"
    ,"easeInOutBack"=>"easeInOutBack"
    ,"easeInBounce"=>"easeInBounce"
    ,"easeOutBounce"=>"easeOutBounce"
    ,"easeInOutBounce"=>"easeInOutBounce" 
  );
  var $_fx_trigger=array(null=>'マウスホバー', 'scroll'=>'スクロール');
  var $_transition_timing=array('ease'=>'ease', 'linear'=>'linear', 'ease-in'=>'ease-in', 'ease-out'=>'ease-out', 'ease-in-out'=>'ease-in-out');
  var $_trigger=array(
    0=>'スクロール'
    ,1=>'クリック'
    ,2=>'マウスホバー'  
  );
  
	//▲変数宣言///////////////////
	
	function bSuperUnit2()
	{
		$this->__construct();
	}

	function __construct()
	{
		unitCommon::__construct();
	}
	//-----------------

	//出力データセット処理（必須）
	function setDisplayData() {
    if(!class_exists("imgmngrDB")){
      include LIB_PATH."/common/imgmngrDB.php";
    }
    $this->_data = $this->getDetail();
    $layout="layout01.tpl";
    $unit_css = array();
		//▼データ操作  ////////
		if($this->_data!=null){
      $this->_data["class"]=$this;
      //レイアウト
      $ls=$this->getLayout();
      $layout = $ls[$this->_data["layout"]];
      
      if(defined("SP_FLG") && SP_FLG==SP_FLG_CODE){
        //レイアウト
        $ls=$this->getLayout(true);
        //$layout = $ls[$this->_data["layout_sp"]];
      
				if(is_numeric($this->_data["bg_color_sp"])) $this->_data["bg_color"] = $this->_data["bg_color_sp"];
				if(is_numeric($this->_data["bdr_type_sp"])) $this->_data["bdr_type"] = $this->_data["bdr_type_sp"];
				if(is_numeric($this->_data["btm_padding_sp"])) $this->_data["btm_padding"] = $this->_data["btm_padding_sp"];

        $this->_data["mt"] = $this->_data["mtsp"];
				$this->_data["mr"] = $this->_data["mrsp"];
				$this->_data["mb"] = $this->_data["mbsp"];
        $this->_data["ml"] = $this->_data["mlsp"];
        
        $this->_data["pt"] = $this->_data["ptsp"];
				$this->_data["pr"] = $this->_data["prsp"];
				$this->_data["pb"] = $this->_data["pbsp"];
        $this->_data["pl"] = $this->_data["plsp"];
			}    
		}

		//▲データ操作  ////////
		$this -> _view -> assign('pageu_code', $this->_pageu_code);
    $this -> _view -> assign('layout', empty($layout) ? "layout01.tpl": $layout );
    $this -> _view -> assign('item_tpl', dirname(__FILE__)."/item.tpl" );
    $this -> _view -> assign('js_tpl', dirname(__FILE__)."/js.tpl" );
    $this -> _view -> assign('ua', $this->_ua);

		return $this->_data;
	}
  
	/*
	 * DBより保存データ取得
	 * 改変可能
	 */
	function getDetail() {
    $data=array();
    $a=array("mt", "mr", "mb", "ml", "pt", "pr", "pb", "pl","mtsp", "mrsp", "mbsp", "mlsp", "ptsp", "prsp", "pbsp", "plsp");
    $sql = "select * from ".$this->getTbl()." where pageu_code = ?";
		if(isset($this->_pageu_code)&&is_numeric($this->_pageu_code)) {
			$result = $this->db->prepare($sql,$this->_pageu_code);      
			$data=$result->fetchRow(DB_FETCHMODE_ASSOC);
      if($data){
        $data=$this->replaceMultipleData($data, $this->column_link);     
        foreach($a as $key){
          if(is_numeric($data[$key])){
            $data[$key] = $data[$key]."px";
          }
        }
        $data["fx_option"] = explode($this->_separator, $data["fx_option"]);
      }
    }
		return $data;
	}


	function setDefault()
	{
    $this->_view->assign('addCss', "\n<link href=\"".BINGOTOPURL."/usr-data/extunits/".$this->_unit_dir."/admin/admin.css\" rel=\"stylesheet\" type=\"text/css\" media=\"all\">\n");
  
		$this->_data = $this->getDetail();
    if(!$this->_data){
      $this->_data["layout"] = $this->_data["layout_sp"] = 0;
      $this->_data["trsf_opacity"] = 100;
      $this->_data["trsf_translate_x"] = 0;
      $this->_data["trsf_translate_y"] = 0;
      $this->_data["trsf_translate_z"] = 0;
      $this->_data["trsf_scale_x"] = 1;
      $this->_data["trsf_scale_y"] = 1;
      $this->_data["trsf_scale_z"] = 1;
      $this->_data["trsf_rotate_x"] = 0;
      $this->_data["trsf_rotate_y"] = 0;
      $this->_data["trsf_rotate_z"] = 0;
      $this->_data["trsf_skew_x"] = 0;
      $this->_data["trsf_skew_y"] = 0;
      /*
      $this->_data["trsf_opacity_to"] = 1;
      $this->_data["trsf_translate_x_to"] = 0;
      $this->_data["trsf_translate_y_to"] = 0;
      $this->_data["trsf_translate_z_to"] = 0;
      $this->_data["trsf_scale_x_to"] = 1;
      $this->_data["trsf_scale_y_to"] = 1;
      $this->_data["trsf_scale_z_to"] = 1;
      $this->_data["trsf_rotate_x_to"] = 0;
      $this->_data["trsf_rotate_y_to"] = 0;
      $this->_data["trsf_rotate_z_to"] = 0;
      $this->_data["trsf_skew_x_to"] = 0;
      $this->_data["trsf_skew_y_to"] = 0;
      */
      
      $this->_data["trsf_perspective"] = "none";
      $this->_data["trsf_duration"] = 1;
      $this->_data["trsf_delay"] = 0;
      $this->_data["trsf_sensitivity"] = 200;
    }
    
    $this->_view->assign("data", $this->_data);
		$this->_form->setDefaults($this->_data);
	}

	//フォームエレメントの作成
	function setElements()
	{
		$this->_form->addElement('hidden','pageu_code', $this->_pageu_code,array("id"=>"pageu_code")); //ページコード
    
    //アンカー用テキスト
    $this->_form->addElement('text', 'anchor_text', null, array('id'=>'anchor_text', 'class'=>'txt wl'));
    
    //alt
    $this->_form->addElement('text', 'alt_text', null, array('id'=>'alt_text', 'class'=>'txt wl'));
    
    //マージン・上下左右
    $this->_form->addElement('text', 'mt', null, array('id'=>'mt', 'class'=>'num'));
    $this->_form->addElement('text', 'mr', null, array('id'=>'mr', 'class'=>'num'));
    $this->_form->addElement('text', 'mb', null, array('id'=>'mb', 'class'=>'num'));
    $this->_form->addElement('text', 'ml', null, array('id'=>'ml', 'class'=>'num'));
    
    //パディング・上下左右
    $this->_form->addElement('text', 'pt', null, array('id'=>'pt', 'class'=>'num'));
    $this->_form->addElement('text', 'pr', null, array('id'=>'pr', 'class'=>'num'));
    $this->_form->addElement('text', 'pb', null, array('id'=>'pb', 'class'=>'num'));
    $this->_form->addElement('text', 'pl', null, array('id'=>'pl', 'class'=>'num'));
    
    //マージン・上下左右
    $this->_form->addElement('text', 'mtsp', null, array('id'=>'mtsp', 'class'=>'num'));
    $this->_form->addElement('text', 'mrsp', null, array('id'=>'mrsp', 'class'=>'num'));
    $this->_form->addElement('text', 'mbsp', null, array('id'=>'mbsp', 'class'=>'num'));
    $this->_form->addElement('text', 'mlsp', null, array('id'=>'mlsp', 'class'=>'num'));
    
    //パディング・上下左右
    $this->_form->addElement('text', 'ptsp', null, array('id'=>'ptsp', 'class'=>'num'));
    $this->_form->addElement('text', 'prsp', null, array('id'=>'prsp', 'class'=>'num'));
    $this->_form->addElement('text', 'pbsp', null, array('id'=>'pbsp', 'class'=>'num'));
    $this->_form->addElement('text', 'plsp', null, array('id'=>'plsp', 'class'=>'num'));
    

    $this->_form->addElement('text', 'border_radius', null, array('id'=>'border_radius', 'class'=>'num', 'placeholder'=>''));
    $this->_form->addElement('text', 'border_width', null, array('id'=>'border_width', 'class'=>'num', 'placeholder'=>''));
    $this->_form->addElement('text', 'border_color', null, array('id'=>'border_color', 'class'=>'color', 'placeholder'=>''));
    $this->_form->addElement('select', 'border_style', null, array('solid'=>'solid', 'dotted'=>'dotted'), array('id'=>'border_style', 'class'=>'pulldown'));    
    
    $this->_form->addElement('text', 'border_radius_anim', null, array('id'=>'border_radius_anim', 'class'=>'num', 'placeholder'=>''));
    $this->_form->addElement('text', 'border_width_anim', null, array('id'=>'border_width_anim', 'class'=>'num', 'placeholder'=>''));
    $this->_form->addElement('text', 'border_color_anim', null, array('id'=>'border_color_anim', 'class'=>'color', 'placeholder'=>''));
    $this->_form->addElement('select', 'border_style_anim', null, array('solid'=>'solid', 'dotted'=>'dotted'), array('id'=>'border_style_anim', 'class'=>'pulldown'));    
    //$this->_form->addElement('text', 'bgcolor', null, array('id'=>'bgcolor', 'class'=>'color', 'placeholder'=>''));
    
    //サイズ
    $this->_form->addElement('select', 'size', null, $this->_size, array('id'=>'size', 'class'=>'pulldown'));
    
    //画像
    $this->_form->addElement('hidden', 'image_code', null, array('id'=>'image_code'));
    $this->_form->addElement('hidden', 'image_path', null, array('id'=>'image_path'));
    $this->_form->addElement('hidden', 'image_w', null, array('id'=>'image_w'));
    $this->_form->addElement('hidden', 'image_h', null, array('id'=>'image_h'));
    
    //画像ホバー
    $this->_form->addElement('hidden', 'image_hv_code', null, array('id'=>'image_hv_code'));
    $this->_form->addElement('hidden', 'image_hv_path', null, array('id'=>'image_hv_path'));
    $this->_form->addElement('hidden', 'image_hv_w', null, array('id'=>'image_hv_w'));
    $this->_form->addElement('hidden', 'image_hv_h', null, array('id'=>'image_hv_h'));
    
    //リンク
    $this->_form->addElement('select', 'link_target', null, $this->_link_target, array('id'=>'link_target', 'class'=>'pulldown'));
    $this->_form->addElement('text', 'link_href', null, array('id'=>'link_href', 'size'=>'40'));
    
    //エフェクト
    $this->_form->addElement('select', 'fx_type', null, $this->_fx_type, array('id'=>'fx_type', 'class'=>'pulldown'));
    $this->_form->addElement('text', 'fx_duration', null, array('id'=>'fx_duration', 'class'=>'num'));
    
    //イージング
    $this->_form->addElement('select', 'fx_option[0]', null, $this->ease, array('id'=>'fx_option_0', 'class'=>'fx_option_0'));
    //拡大率
    $this->_form->addElement('text', 'fx_option[1]', null, array('id'=>'fx_option_1', 'class'=>'fx_option_1 num'));
    //縮小率
    $this->_form->addElement('text', 'fx_option[2]', null, array('id'=>'fx_option_2', 'class'=>'fx_option_2 num'));
    //
    $this->_form->addElement('select', 'fx_option[3]', null, $this->_fx_trigger, array('id'=>'fx_option_3', 'class'=>'fx_option_3'));
    
    $this->_form->addElement('advcheckbox', 'fx_option[4]', null, 'エフェクト時に元画像を透過にする', array('id'=>'fx_option_4', 'class'=>'check'), array(0,1));
    
    //整列
    $this->_form->addElement('select', 'align', null, $this->_align, array('id'=>'align', 'class'=>'pulldown'));
    
    
       
       
    
    $this->_form->addElement('text', 'trsf_opacity', null, array('id'=>'trsf_opacity', 'class'=>'num'));
    $this->_form->addElement('text', 'trsf_translate_x', null, array('id'=>'trsf_translate_x', 'class'=>'num'));
    $this->_form->addElement('text', 'trsf_translate_y', null, array('id'=>'trsf_translate_y', 'class'=>'num'));
    $this->_form->addElement('text', 'trsf_translate_z', null, array('id'=>'trsf_translate_z', 'class'=>'num'));
    $this->_form->addElement('text', 'trsf_scale_x', null, array('id'=>'trsf_scale_x', 'class'=>'num'));
    $this->_form->addElement('text', 'trsf_scale_y', null, array('id'=>'trsf_scale_y', 'class'=>'num'));
    $this->_form->addElement('text', 'trsf_scale_z', null, array('id'=>'trsf_scale_z', 'class'=>'num'));
    $this->_form->addElement('text', 'trsf_rotate_x', null, array('id'=>'trsf_rotate_x', 'class'=>'num'));
    $this->_form->addElement('text', 'trsf_rotate_y', null, array('id'=>'trsf_rotate_y', 'class'=>'num'));
    $this->_form->addElement('text', 'trsf_rotate_z', null, array('id'=>'trsf_rotate_z', 'class'=>'num'));
    $this->_form->addElement('text', 'trsf_skew_x', null, array('id'=>'trsf_skew_x', 'class'=>'num'));
    $this->_form->addElement('text', 'trsf_skew_y', null, array('id'=>'trsf_skew_y', 'class'=>'num'));
    /*
    $this->_form->addElement('text', 'trsf_opacity_to', null, array('id'=>'trsf_opacity_to', 'class'=>'num'));
    $this->_form->addElement('text', 'trsf_translate_x_to', null, array('id'=>'trsf_translate_x_to', 'class'=>'num'));
    $this->_form->addElement('text', 'trsf_translate_y_to', null, array('id'=>'trsf_translate_y_to', 'class'=>'num'));
    $this->_form->addElement('text', 'trsf_translate_z_to', null, array('id'=>'trsf_translate_z_to', 'class'=>'num'));
    $this->_form->addElement('text', 'trsf_scale_x_to', null, array('id'=>'trsf_scale_x_to', 'class'=>'num'));
    $this->_form->addElement('text', 'trsf_scale_y_to', null, array('id'=>'trsf_scale_y_to', 'class'=>'num'));
    $this->_form->addElement('text', 'trsf_scale_z_to', null, array('id'=>'trsf_scale_z_to', 'class'=>'num'));
    $this->_form->addElement('text', 'trsf_rotate_x_to', null, array('id'=>'trsf_rotate_x_to', 'class'=>'num'));
    $this->_form->addElement('text', 'trsf_rotate_y_to', null, array('id'=>'trsf_rotate_y_to', 'class'=>'num'));
    $this->_form->addElement('text', 'trsf_rotate_z_to', null, array('id'=>'trsf_rotate_z_to', 'class'=>'num'));
    $this->_form->addElement('text', 'trsf_skew_x_to', null, array('id'=>'trsf_skew_x_to', 'class'=>'num'));
    $this->_form->addElement('text', 'trsf_skew_y_to', null, array('id'=>'trsf_skew_y_to', 'class'=>'num'));
    */
    $this->_form->addElement('text', 'trsf_perspective', null, array('id'=>'trsf_perspective', 'class'=>'num'));
    $this->_form->addElement('text', 'trsf_duration', null, array('id'=>'trsf_duration', 'class'=>'num'));
    $this->_form->addElement('text', 'trsf_delay', null, array('id'=>'trsf_delay', 'class'=>'num'));
    $this->_form->addElement('select', 'trsf_easing', null, $this->_transition_timing, array('id'=>'trsf_easing'));
    $this->_form->addElement('text', 'trsf_easing_cubic', null, array('id'=>'trsf_easing_cubic', 'class'=>'ws', 'placeholder'=>'cubic-bezier'));
    $this->_form->addElement('text', 'trsf_sensitivity', null, array('id'=>'trsf_sensitivity', 'class'=>'num'));
    $this->_form->addElement('text', 'trsf_background_color', null, array('id'=>'trsf_background_color', 'class'=>'color'));
    $this->_form->addElement('text', 'trsf_border_color', null, array('id'=>'trsf_border_color', 'class'=>'color'));
    $this->_form->addElement('advcheckbox', 'trsf_reverse', null, '&nbsp;初回のみ動作させる', array('id'=>'trsf_reverse'), array(1, 0));
    $this->_form->addElement('select', 'trsf_trigger', null, $this->_trigger, array('id'=>'trsf_trigger'));    
    $this->_form->addElement('select', 'trsf_pos_type', null, $this->_transition_type, array('id'=>'trsf_pos_type'));

		$this -> _view -> assign("unit_dir",$this->_unit_dir);
	}

	//フォーム入力エラーチェックの設定
	function setRules()
	{
		$this->_form->applyFilter('__ALL__','trim');
		$this->_form->_submitValues = DataBase::ConvColumnVals($this->_form->_submitValues,$this->columns); //ルールに従った値変換、タグの除去
		$this->_form->setJsWarnings('下記の項目が不正です。','');
		$this->_form->addRule('pageu_code','・「ユニットコード」が不明です。コンテンツ管理よりやり直してください','required',null,$this->erchk);
		
    /*   
    //・フォントサイズには数値を入力してください
    $this->_form->addRule("mlt_data1_fsize", _gettext('B_P00989'), "numeric", null, "server");  
    $this->_form->registerRule('NumericRange', 'callback','NumericRange');
    //・フォントサイズは1〜100で入力してください
    $this->_form->addRule('mlt_data1_fsize',_gettext('B_P00662'),'NumericRange',array(1,100),$this->erchk);
     */
     $this->_form->registerRule("NumericRange", "callback", "NumericRange");
     
    $this->_form->registerRule("check_css_color", "regex", "/^#[0-9a-fA-F]{3}$|^#[0-9a-fA-F]{6}$/");
    $this->_form->registerRule("check_css_property", "regex", "/^\d+$|\d+(px|em|pt|%)$|^auto$/");
    $this->_form->addRule("mt", _gettext('B_P00991', '余白'), "check_css_property", null, "server");
    $this->_form->addRule("mr", _gettext('B_P00991', '余白'), "check_css_property", null, "server");
    $this->_form->addRule("mb", _gettext('B_P00991', '余白'), "check_css_property", null, "server");
    $this->_form->addRule("ml", _gettext('B_P00991', '余白'), "check_css_property", null, "server");
    $this->_form->addRule("pt", _gettext('B_P00991', '余白'), "check_css_property", null, "server");
    $this->_form->addRule("pr", _gettext('B_P00991', '余白'), "check_css_property", null, "server");
    $this->_form->addRule("pb", _gettext('B_P00991', '余白'), "check_css_property", null, "server");
    $this->_form->addRule("pl", _gettext('B_P00991', '余白'), "check_css_property", null, "server");
    
    $this->_form->addRule("mt_sp", _gettext('B_P00991', '余白'), "check_css_property", null, "server");
    $this->_form->addRule("mr_sp", _gettext('B_P00991', '余白'), "check_css_property", null, "server");
    $this->_form->addRule("mb_sp", _gettext('B_P00991', '余白'), "check_css_property", null, "server");
    $this->_form->addRule("ml_sp", _gettext('B_P00991', '余白'), "check_css_property", null, "server");
    $this->_form->addRule("pt_sp", _gettext('B_P00991', '余白'), "check_css_property", null, "server");
    $this->_form->addRule("pr_sp", _gettext('B_P00991', '余白'), "check_css_property", null, "server");
    $this->_form->addRule("pb_sp", _gettext('B_P00991', '余白'), "check_css_property", null, "server");
    $this->_form->addRule("pl_sp", _gettext('B_P00991', '余白'), "check_css_property", null, "server");
    
    $this->_form->addRule("border_width", _gettext('B_P00991', '枠線の太さ'), "check_css_property", null, "server");
    $this->_form->addRule("border_radius", _gettext('B_P00991', '枠線のラウンド'), "check_css_property", null, "server");
    $this->_form->addRule("border_color", _gettext('B_P01027', '枠線の色'), "check_css_color", null, "server");
    
    $this->_form->addRule("image_code", _gettext('B_P01029', '画像'), "required", null, "server");
    $this->_form->addRule("image_hv_code", _gettext('B_P01029', '画像（ホバー）'), "required", null, "server");
    
    
        //拡大率
    $this->_form->addRule('fx_option[1]', _gettext('B_P01037', array('拡大率', 100, 200)),'NumericRange',array(100,200),$this->erchk);
    //縮小率
    $this->_form->addRule('fx_option[2]', _gettext('B_P01037', array('縮小率', 10, 100)),'NumericRange',array(10,100),$this->erchk);
    
	}

	//データ下書き保存処理
	function doSave($post)
	{
    include LIB_PATH."/common/imgmngrDB.php";
  
		if(!is_numeric($post['pageu_code'])){
			return "・データの保存に失敗しました";
		}       
    ksort($post['fx_option']);
    $post["fx_option"] = implode($this->_separator, $post["fx_option"]);
    $post= $this->replaceMultipleData($post, $this->column_link, "mlt_data", true);
    //既存データがあるか確認
		$old_data = $this->getDetail();
		$record = null;
		foreach($this->columns as $val) {
			if($post[$val["column"]]!=null){
				$record[$val["column"]] = $post[$val["column"]];
			}else{
        $record[$val["column"]] = null;
      }
		}

    $record["pageu_unit_code"] = $this->_unit_data["unit_code"];
    $record["pageu_unit_name"] = $this->_unit_data["unit_name"];
    $record["btm_padding"] = 0;
    $record["btm_padding_sp"] = 0;

    //画像処理
    $cparr=array();
    //画像
    if($post["del_flg"] == 1){
      $record["mlt_data25"]=null;
      $record["mlt_data26"]=null;
      $record["mlt_data27"]=null;
      $record["mlt_data28"]=null;
    }else{
      if(is_numeric($record["mlt_data25"])) {	
        $post_img_data=$record["mlt_data25"];
        $old_img_data=null;
        if(!empty($old_data["mlt_data25"])){
          $old_img_data=$old_data["mlt_data25"];
        }
        //画像コードが違う時だけ処理
        $imginfo=null;
        if($post_img_data != $old_img_data || empty($record["mlt_data26"])){
          $imgmngrDB = new imgmngrDB();
          $imgdata = $imgmngrDB->getImageFromCode($post_img_data, UNITS_IMG_PATH, $post["pageu_code"], 1);
          if(isset($imgdata)){
            $data_path = $imgdata["img_src"]; // コピー元（素材管理の画像パス）
            $img_path = $imgdata["gimg_src"];	// コピー先（公開用の画像パス）
            $imginfo=getimagesize(BASE_PATH.$data_path);
            $record["mlt_data26"] = array_pop(explode('/',$img_path)); //保存ファイル名取得
            $record["mlt_data27"] = $imginfo[0];//width
            $record["mlt_data28"] = $imginfo[1];//height
            $cparr[0][$data_path] = $img_path;
          }else{
            return _gettext('B_P00651');
          }
        }
      }
    }
    
    //ホバー画像
    if($post["del_flg_hv"] == 1){
      $record["mlt_data29"]=null;
      $record["mlt_data30"]=null;
      $record["mlt_data31"]=null;
      $record["mlt_data32"]=null;
    }else{
      if(is_numeric($record["mlt_data29"])) {	
        $post_img_data=$record["mlt_data29"];
        $old_img_data=null;
        if(!empty($old_data["mlt_data29"])){
          $old_img_data=$old_data["mlt_data29"];
        }
        //画像コードが違う時だけ処理
        $imginfo=null;
        if($post_img_data != $old_img_data || empty($record["mlt_data30"])){
          $imgmngrDB = new imgmngrDB();
          $imgdata = $imgmngrDB->getImageFromCode($post_img_data, UNITS_IMG_PATH, $post["pageu_code"], 2);
          if(isset($imgdata)){
            $data_path = $imgdata["img_src"]; // コピー元（素材管理の画像パス）
            $img_path = $imgdata["gimg_src"];	// コピー先（公開用の画像パス）
            $imginfo=getimagesize(BASE_PATH.$data_path);
            $record["mlt_data30"] = array_pop(explode('/',$img_path)); //保存ファイル名取得
            $record["mlt_data31"] = $imginfo[0];//width
            $record["mlt_data32"] = $imginfo[1];//height
            $cparr[1][$data_path] = $img_path;
          }else{
            return _gettext('B_P00651');
          }
        }
      }
    }

    
		$this->db->query('BEGIN');
		//保存処理開始
    //基本データ
		if(is_array($old_data)&& count($old_data)>0) {
			//更新
			if(!$this->db->update($this->getTbl(),$record, "pageu_code=".$record["pageu_code"])) {
				$this->db->query('ROLLBACK');
				return "・データの保存に失敗しました";
			}
		} else { //新規
			if(!$this->db->insert($this->getTbl(),$record)) {
				$this->db->query('ROLLBACK');
				return "・データの保存に失敗しました";
			}
		}

    
    if(is_array($cparr) && count($cparr)>0){
      //ASP用　ファイルサイズチェック
      if(defined('PRODUCT_VERSION')){
        $fsize = array();       
        foreach($cparr as $k=>$v){
          foreach($v as $src=>$dist){
            $fsize[] = array('size' => filesize(BASE_PATH.$src));
          }
        }
        if (count($fsize)>0 && !commonFile::chkSaveFiles($fsize)) {
          $this->db->query('ROLLBACK');
          return _gettext('B_P00281');
        }
      }
      //画像保存
      foreach($cparr as $k=>$v){
        foreach($v as $src=>$dist){
          if(!@copy(BASE_PATH.$src, BASE_PATH.$dist)){
            $this->db->query('ROLLBACK');
            return _gettext('B_P00650');
          } else {
            @chmod(BASE_PATH.$dist, 0666);
          }
        }
      }
    }

		$this -> db -> query("COMMIT");
		return null;
	}


	//公開処理
	function TmptoCommon($pageu_code, $db) {
		if(!parent::TmptoCommon($pageu_code, $db)){
      return false;
    }
    /*
    if(isset($this->_table2)&&$this->_table2!=null&&isset($this->_tmptable2)&&$this->_tmptable2!=null) {
			if(!$db->delete($this->_table2, "umlt_pageu_code=".$pageu_code)) {
				return false;
			}
			$sql = "INSERT INTO ".$this->_table2." (SELECT * FROM ".$this->_tmptable2." where umlt_pageu_code = ".$pageu_code.")";
			return $db->query($sql);
		}
    */
		return true;
    
	}
  
  	/*
	 * ロールバック（下書きテーブルへ公開データをコピー）（共通）
	 * pageView.phpが呼びます、ロールバック、コミットはpageViewにて行うのでbooleanで返してください。
	 */
	function CommonToTmp($pageu_code,$db) {
    if(!parent::CommonToTmp($pageu_code, $db)){
      return false;
    }
    /*
		if(isset($this->_table2)&&$this->_table2!=null&&isset($this->_tmptable2)&&$this->_tmptable2!=null) {
			if(!$db->delete($this->_tmptable2, "umlt_pageu_code=".$pageu_code)) {
				return false;
			}
			$sql = "INSERT INTO ".$this->_tmptable2." (SELECT * FROM ".$this->_table2." where umlt_pageu_code = ".$pageu_code.")";
			return $db->query($sql);
		}
    */
		return true;
	}
  

	/*
	 * ユニット複製処理（共通）
	 * page-unitlayout.phpより呼ばれます
	 * トランザクション処理は呼び元で行います
	 * @param $pageu_code コピー元のコード
	 * @param $target_pageu_code コピー先のコード
	 */
	function unitCopy($pageu_code, $target_pageu_code, $db, $itemcopy=false) {
		if(!parent::unitCopy($pageu_code, $target_pageu_code, $db, $itemcopy)){
      return false;
    }
    /*
    //本体のテーブル複製が終わったら子供のテーブルも複製する
    $this->db->query('BEGIN');
    $sql = "select * from ".$this->_tmptable2." where umlt_pageu_code = '{$pageu_code}'";
    $result = $db->query($sql);
    $cpimg=array();
    if($result) {
      while ($copyrecord = $result->fetchRow(DB_FETCHMODE_ASSOC)){
        $copyrecord["umlt_pageu_code"] = $target_pageu_code;
        // mysql対応
        //unset($copyrecord["blist2d_pk"]);
        $copyrecord["umlt_code"] = $this->db->getKey("unit_multiple_data2_umlt_code");

        if(!$db->insert($this->_tmptable2, $copyrecord)) {
          $this->db->query('ROLLBACK');
          return false;
          exit();
        }
      }
    } else {
        $this->db->query('ROLLBACK');
        return false;
        exit();
    }
    */
    $this->db->query('COMMIT');
    return true;
    exit();
	}
  
  /**レイアウトリスト取得
  *@param boolean $so
  */
  function getLayout($sp=false){
    $list=array();
    $dir = dirname(__FILE__)."/tpl";
    if($sp) $dir.="_sp";
    if ($dh = opendir($dir)) {
      while (($file = readdir($dh)) !== false) {
        if($file!="." && $file!=".." && !preg_match("/^_.*|^admin.*/",$file)){
          if(preg_match("/.*\.tpl$/", $file)){
            $list[]=$file;
          }
        }
      }
      closedir($dh);
    }
    sort($list);
    return $list;
  }
}
?>